# IFrictionlessComplianceModule

[Git Source](https://gitlab.com/dfyclabs/protocol/dfyclabs-tokens/blob/85f6dfa54ce0787eb1b1345bd6726f84fe766c54/contracts/interface/rules/IFrictionlessComplianceModule.sol)

**Inherits:** IModule

**Author:** DEFYCA Labs S.à.r.l

Copyright © 2023 DEFYCA Labs S.à.r.l Permission is hereby granted, free of charge, to any person obtaining a copy of the Frictionless protocol smart contracts (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice (including the next paragraph) shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL DEFYCA LABS S.à.r.l BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

The IFrictionlessCompliance is responsible for the compliant transfer of the various Tokens in the Frictionless protocol.

## Functions

### setPermissionsManager

*Sets the instance of the `IFrictionlessPermissionsManager` to determine permissions for users.*

```solidity
function setPermissionsManager(address frictionlessPermissionsManager_) external;
```

**Parameters**

| Name                              | Type      | Description                                                   |
| --------------------------------- | --------- | ------------------------------------------------------------- |
| `frictionlessPermissionsManager_` | `address` | the address of the `IFrictionlessPermissionsManager` contract |

### setComplianceFactory

*Sets the instance of the `IFrictionlessComplianceFactory` to determine the compliance module for the protocol.*

```solidity
function setComplianceFactory(address newComplianceFactory_) external;
```

**Parameters**

| Name                    | Type      | Description                                                  |
| ----------------------- | --------- | ------------------------------------------------------------ |
| `newComplianceFactory_` | `address` | the address of the `IFrictionlessComplianceFactory` contract |

### permissionsManager

*Gets the instance of the `IFrictionlessPermissionsManager` to determine permissions for users.*

```solidity
function permissionsManager() external view returns (IFrictionlessPermissionsManager);
```

**Returns**

| Name     | Type                              | Description                                                   |
| -------- | --------------------------------- | ------------------------------------------------------------- |
| `<none>` | `IFrictionlessPermissionsManager` | the address of the `IFrictionlessPermissionsManager` contract |

### complianceFactory

*Gets the instance of the `IFrictionlessComplianceFactory` to determine the compliance module for the protocol.*

```solidity
function complianceFactory() external view returns (IFrictionlessComplianceFactory);
```

**Returns**

| Name     | Type                             | Description                                                  |
| -------- | -------------------------------- | ------------------------------------------------------------ |
| `<none>` | `IFrictionlessComplianceFactory` | the address of the `IFrictionlessComplianceFactory` contract |

### isTreasury

*Verifies if the specified wallet address is a PROTOCOL\_TREASURY user.*

```solidity
function isTreasury(address walletAddress_) external view returns (bool);
```

**Parameters**

| Name             | Type      | Description                      |
| ---------------- | --------- | -------------------------------- |
| `walletAddress_` | `address` | the address of the users wallet. |

**Returns**

| Name     | Type   | Description                                                                        |
| -------- | ------ | ---------------------------------------------------------------------------------- |
| `<none>` | `bool` | true if the specified wallet address is a PROTOCOL\_TREASURY user, otherwise false |

### isCustodian

*Verifies if the specified wallet address is a PERMISSIONED\_CUSTODIAN user.*

```solidity
function isCustodian(address walletAddress_) external view returns (bool);
```

**Parameters**

| Name             | Type      | Description                      |
| ---------------- | --------- | -------------------------------- |
| `walletAddress_` | `address` | the address of the users wallet. |

**Returns**

| Name     | Type   | Description                                                                             |
| -------- | ------ | --------------------------------------------------------------------------------------- |
| `<none>` | `bool` | true if the specified wallet address is a PERMISSIONED\_CUSTODIAN user, otherwise false |

### isInvestor

*Verifies if the specified wallet address is a PERMISSIONED\_INVESTOR user.*

```solidity
function isInvestor(address walletAddress_) external view returns (bool);
```

**Parameters**

| Name             | Type      | Description                      |
| ---------------- | --------- | -------------------------------- |
| `walletAddress_` | `address` | the address of the users wallet. |

**Returns**

| Name     | Type   | Description                                                                            |
| -------- | ------ | -------------------------------------------------------------------------------------- |
| `<none>` | `bool` | true if the specified wallet address is a PERMISSIONED\_INVESTOR user, otherwise false |

### isManager

*Verifies if the specified wallet address is a PERMISSIONED\_MANAGER user.*

```solidity
function isManager(address walletAddress_) external view returns (bool);
```

**Parameters**

| Name             | Type      | Description                      |
| ---------------- | --------- | -------------------------------- |
| `walletAddress_` | `address` | the address of the users wallet. |

**Returns**

| Name     | Type   | Description                                                                           |
| -------- | ------ | ------------------------------------------------------------------------------------- |
| `<none>` | `bool` | true if the specified wallet address is a PERMISSIONED\_MANAGER user, otherwise false |

### isCalculatingAgent

*Verifies if the specified wallet address is a PERMISSIONED\_CALCULATING\_AGENT user.*

```solidity
function isCalculatingAgent(address walletAddress_) external view returns (bool);
```

**Parameters**

| Name             | Type      | Description                      |
| ---------------- | --------- | -------------------------------- |
| `walletAddress_` | `address` | the address of the users wallet. |

**Returns**

| Name     | Type   | Description                                                                                      |
| -------- | ------ | ------------------------------------------------------------------------------------------------ |
| `<none>` | `bool` | true if the specified wallet address is a PERMISSIONED\_CALCULATING\_AGENT user, otherwise false |

### isTransferAgent

*Verifies if the specified wallet address is a PERMISSIONED\_TRANSFER\_AGENT user.*

```solidity
function isTransferAgent(address walletAddress_) external view returns (bool);
```

**Parameters**

| Name             | Type      | Description                      |
| ---------------- | --------- | -------------------------------- |
| `walletAddress_` | `address` | the address of the users wallet. |

**Returns**

| Name     | Type   | Description                                                                                   |
| -------- | ------ | --------------------------------------------------------------------------------------------- |
| `<none>` | `bool` | true if the specified wallet address is a PERMISSIONED\_TRANSFER\_AGENT user, otherwise false |

### isFundAccountant

*Verifies if the specified wallet address is a PERMISSIONED\_FUND\_ACCOUNTANT user.*

```solidity
function isFundAccountant(address walletAddress_) external view returns (bool);
```

**Parameters**

| Name             | Type      | Description                      |
| ---------------- | --------- | -------------------------------- |
| `walletAddress_` | `address` | the address of the users wallet. |

**Returns**

| Name     | Type   | Description                                                                                    |
| -------- | ------ | ---------------------------------------------------------------------------------------------- |
| `<none>` | `bool` | true if the specified wallet address is a PERMISSIONED\_FUND\_ACCOUNTANT user, otherwise false |

### isUser

*Verifies if the specified wallet address is a permissioned user in the Frictionless protocol.*

```solidity
function isUser(address walletAddress_) external view returns (bool);
```

**Parameters**

| Name             | Type      | Description                      |
| ---------------- | --------- | -------------------------------- |
| `walletAddress_` | `address` | the address of the users wallet. |

**Returns**

| Name     | Type   | Description                                                                                               |
| -------- | ------ | --------------------------------------------------------------------------------------------------------- |
| `<none>` | `bool` | true if the specified wallet address is a permissioned user in the Frictionless protocol, otherwise false |

### hasClaim

*verify if the userAddress is permissioned in the Frictionless protocol and has a valid claim*

```solidity
function hasClaim(address userAddress_, IFrictionlessPermissionsManager.FrictionlessPermissionedUser userType_)
    external
    view
    returns (bool);
```

**Parameters**

| Name           | Type                                                           | Description                                |
| -------------- | -------------------------------------------------------------- | ------------------------------------------ |
| `userAddress_` | `address`                                                      | the address of the user's wallet to verify |
| `userType_`    | `IFrictionlessPermissionsManager.FrictionlessPermissionedUser` | the type of the user as per the enum       |

**Returns**

| Name     | Type   | Description                                                               |
| -------- | ------ | ------------------------------------------------------------------------- |
| `<none>` | `bool` | true if a valid permissioned user and has a valid claim, otherwise false. |

## Events

### FrictionlessTokenTransferred

*Event emitted during compliance module transfers*

```solidity
event FrictionlessTokenTransferred(
    IBasicFrictionlessToken.FrictionlessTokenTypes tokenType,
    address tokenAddr,
    address from,
    address to,
    uint256 amount
);
```

## Errors

### FrictionlessIsZeroAddress

*throws if specific address is zero.*

```solidity
error FrictionlessIsZeroAddress(string);
```

### FrictionlessComplianceModuleInvalidCompliance

*thrown if the compliance module address is invalid during `bindCompliance` and `unBindCompliance`*

```solidity
error FrictionlessComplianceModuleInvalidCompliance(address compliance);
```

### FrictionlessComplianceModuleNotAnApprovedCompliance

*thrown if the compliance module address is not approved during `bindCompliance`*

```solidity
error FrictionlessComplianceModuleNotAnApprovedCompliance(address compliance);
```

### FrictionlessComplianceModuleComplianceIsAlreadyBound

*thrown if the compliance module address is already bound, thrown by `bindCompliance`*

```solidity
error FrictionlessComplianceModuleComplianceIsAlreadyBound(address compliance);
```

### FrictionlessComplianceModuleNotABoundCompliance

*thrown if the compliance module address is not already bound during `unBindCompliance`*

```solidity
error FrictionlessComplianceModuleNotABoundCompliance(address compliance);
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.frictionless.markets/developer/smart-contracts/smart-contract-docs/compliance/ifrictionlesscompliancemodule.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
